#include "IA.h"

using namespace std;

IA::IA()
{
    vector<trainee_moto> trainees=trainees_moto();
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].team==mon_equipe())
        {
            currpos=trainees[i].emplacement[0];
            idMoto=i; // TEMP
            break;
        }
    }
    
    Pathfinding pathfinding(currpos, 120); // début du jeu, I=120
    posList=pathfinding.optimalgen();
}

void IA::tourBegin()
{
    position pos;
    pos.x=-1;
    pos.y=53;
    
    cout << "{DEBUG} " << mon_equipe() << endl;
    for(int i=0;i<posList.size();i++)
    {
        cout << posList[i].x << ";" << posList[0].y << endl;
    }

    if(posList.empty() || !freeway()) // si on ne peut plus aller là où on voulait, ou qu'on a plus de predef
       redefpath();

    for(unsigned i=3; i>0 && posList.size()>0; i--)
    {
        deplacer(idMoto, currpos, posList[0]);
        currpos=posList[0];
        posList.erase(posList.begin());
    }
}

bool IA::freeway()
{
    ArrayMatrix walkary(0,vector<short>());

    // layer 1 : map de base. -1 = walkable
    for(unsigned i=0;i<TAILLE_TERRAIN;i++)
    {
        vector<short> tmp;
        for(unsigned j=0;j<TAILLE_TERRAIN;j++)
        {
            position pos;
            pos.x=j;
            pos.y=i;
            if(case_traversable(pos))
                tmp.push_back(0);
            else
                tmp.push_back(-1);
        }
        walkary.push_back(tmp);
    }


    // layer 2 : path
    for(int i=0;i<TAILLE_TERRAIN;i++)
    {
        for(int j=0;j<TAILLE_TERRAIN;j++)
        {
            if(walkary[i][j] == 0)
                continue;
            bool inpath=false;
            for(unsigned k=0;k<posList.size();k++)
            {
                if(posList[k].x == j && posList[k].y == i)
                {
                    inpath=true;
                    break;
                }
            }
            if(!inpath)
                walkary[i][j]=0; // on ne marche que sur le chemin
        }
    }

    // NEXT STEP : identify areas

    Zonedef zd(walkary);
    zd.exec();

   if(walkary[currpos.y][currpos.x] != walkary[posList[posList.size()-1].y][posList[posList.size()-1].x]) // on est pas dans la même zone
    {
        return false;
    }
    return true;
}

void IA::redefpath()
{
    posList.erase(posList.begin(), posList.end());

    vector<trainee_moto> trainees=trainees_moto();

    int intensity=0;
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].id==idMoto)
            intensity=trainees[i].intensite;
    }

    Pathfinding pathfinding(currpos, intensity);
    posList=pathfinding.optimalgen();
}

