#include "IA.h"

using namespace std;

IA::IA()
{
    inverted=false;
    gene=false;
    vector<trainee_moto> trainees=trainees_moto();
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].team==mon_equipe())
        {
            firstTrainee=trainees[i];
            currpos=trainees[i].emplacement[0];
            idMoto=i; // TEMP
            break;
        }
    }

    Pathfinding pathfinding(currpos, 120); // début du jeu, I=120
    posList=pathfinding.optimalgen();
}

void IA::tourBegin()
{
    unsigned pa=3;


    if(posList.empty() || !freeway()) // si on ne peut plus aller là où on voulait, ou qu'on a plus de predef
    {
        redefpath();
        if(posList.empty()) // on a rien pu ajouter
        {
            if(!inverted)
            {
                inverted=true;

                if(Func::posEq(currpos, firstTrainee.emplacement.back()))
                    currpos=firstTrainee.emplacement.front();
                else
                    currpos=firstTrainee.emplacement.back();

                redefpath();
            }

            /*
             * IMPORTANT !
             * Si d'autres améliorations sont à faire, les placer ici.
             * Le else est un "cas désespéré"
             */

/*            else if(!gene) // office de "else"
            {
                // So, here we go. Le but est de gêner au maximum l'IA adverse
                // Ainsi, propagation en ligne droite jusqu'à rencontrer un
                // obstacle, then tourner et etc.
                // Jusqu'à épuisemeent de l'intensité.
                int nearest=1337, idNearest=1337;
                for(unsigned i=0;i<firstTrainee.emplacement.size();i++)
                {
                    if((abs(TAILLE_TERRAIN/2 - firstTrainee.emplacement[i].x) + abs(TAILLE_TERRAIN/2 - firstTrainee.emplacement[i].y))
                            < nearest)
                    {
                        nearest=abs(TAILLE_TERRAIN/2 - firstTrainee.emplacement[i].x) + abs(TAILLE_TERRAIN/2 - firstTrainee.emplacement[i].y);
                        idNearest=i;
                    }
                }

                Cardinal direct;
                vector<int> distancesToObst; // Distance jusqu'à l'obstacle le plus proche
                for(unsigned i=0;i<4;i++)
                {
                    int dist=0;
                    position cpos=firstTrainee.emplacement[idNearest];
                    Func::incrementCardinalPos(cpos, (Cardinal)i); // (Cardinal)i -> i est utilisé comme un membre de Cardinal,
                                                                   // qui contient 4 possibilités
    
                    while(case_traversable(cpos))
                    {
                        dist++;
                        Func::incrementCardinalPos(cpos, (Cardinal)i);
                    }

                    distancesToObst.push_back(dist);
                }
                
                int best=0, idbest=0;
                for(unsigned i=0;i<distancesToObst.size();i++)
                {
                    if(distancesToObst[i] > best)
                    {
                        best=distancesToObst[i];
                        idbest=i;
                    }
                }
                direct=(Cardinal)idbest;

                position newpos=firstTrainee.emplacement[idNearest];
                Func::incrementCardinalPos(newpos, direct);
                couper_trainee_moto(firstTrainee.id, firstTrainee.emplacement[idNearest], newpos, 120-(firstTrainee.emplacement.size()+5));
                // +5 -> si on a besoin d'agrandir
                
                // récup new id
                vector<int> ids=regarder_trainee_case(newpos);

                if(ids.size()>1)
                    return;

                idMoto=ids[0];
                
                for(int i=0;i<30;i++) // si trop, ce n'est pas grave
                {
                    Func::incrementCardinalPos(newpos, direct);
                    posList.push_back(newpos);
                }
            }
            */

            // PATIE COMMENTEE :
            // Segfaulte, pas le temps de la debug.
        }
    }

    for(; pa>0 && posList.size()>0; pa--)
    {
        deplacer(idMoto, currpos, posList[0]);
        currpos=posList[0];
        posList.erase(posList.begin());
    }
}


bool IA::freeway()
{
    ArrayMatrix walkary(0,vector<short>());

    // layer 1 : map de base. -1 = walkable
    for(unsigned i=0;i<TAILLE_TERRAIN;i++)
    {
        vector<short> tmp;
        for(unsigned j=0;j<TAILLE_TERRAIN;j++)
        {
            position pos;
            pos.x=j;
            pos.y=i;
            if(case_traversable(pos))
                tmp.push_back(0);
            else
                tmp.push_back(-1);
        }
        walkary.push_back(tmp);
    }


    // layer 2 : path
    for(int i=0;i<TAILLE_TERRAIN;i++)
    {
        for(int j=0;j<TAILLE_TERRAIN;j++)
        {
            if(walkary[i][j] == 0)
                continue;
            bool inpath=false;
            for(unsigned k=0;k<posList.size();k++)
            {
                if(posList[k].x == j && posList[k].y == i)
                {
                    inpath=true;
                    break;
                }
            }
            if(!inpath)
                walkary[i][j]=0; // on ne marche que sur le chemin
        }
    }

    // NEXT STEP : identify areas

    Zonedef zd(walkary);
    zd.exec();

    if(walkary[currpos.y][currpos.x] != walkary[posList[posList.size()-1].y][posList[posList.size()-1].x]) // on est pas dans la même zone
    {
        return false;
    }
    return true;
}

void IA::redefpath()
{
    posList.erase(posList.begin(), posList.end());

    vector<trainee_moto> trainees=trainees_moto();

    int intensity=0;
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].id==idMoto)
            intensity=trainees[i].intensite;
    }

    Pathfinding pathfinding(currpos, intensity);
    posList=pathfinding.optimalgen();
}

