#include "pathfinding.h"

using namespace std;

Pathfinding::Pathfinding(position icurrpos, int iintensite) :
    currpos(icurrpos), intensite(iintensite)
{
}

vector<position> Pathfinding::optimalgen()
{
    powerunits=unites_energie();
    for(unsigned i=0;i<powerunits.size();i++)
    {
        if(owned(powerunits[i]))
            powerunits.erase(powerunits.begin()+i);
    }
    
    vector<position> lowpath;
    bool once=true;

    for(unsigned i=0;i<powerunits.size();i++)
    {
        vector<position> tmppath;

        position side=powerunits[i].pos;
        side.x++;

        // heuristic : case la + intéressante
        // TODO

        tmppath = chemin(currpos, side);

        if(tmppath.size()<lowpath.size() || once)
        {
            once=false;
            lowpath=tmppath;
        }
    }

    cout << lowpath.size() << endl;

    return lowpath;
}

bool Pathfinding::owned(unite_energie powunit)
{
    int x=powunit.pos.x, y=powunit.pos.y;

    if(isMyLight(x-1,y) || isMyLight(x-1,y-1) || isMyLight(x,y-1) || isMyLight(x+1,y-1)
            || isMyLight(x+1,y) || isMyLight(x+1,y+1) || isMyLight(x,y+1) || isMyLight(x-1,y+1))
    {
        return true;
    }
    return false;
}

bool Pathfinding::isMyLight(int x, int y)
{
    int me=mon_equipe();

    if(x<0 || x >= TAILLE_TERRAIN || y<0 || y>=TAILLE_TERRAIN) // hors-map
        return false;


    vector<trainee_moto> trainees=trainees_moto(); // on select les trainees

    // eliminat° de celles adverses + reperage de la case cherchee
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].team != me)
            trainees.erase(trainees.begin()+i);
        for(unsigned j=0;j<trainees[i].emplacement.size();j++)
        {
            if(trainees[i].emplacement[j].x == x
                    && trainees[i].emplacement[j].y == y) // same case
                return true;
        }
    }


    return false;
}

