#ifndef DEF_ASTAR
#define DEF_ASTAR

#include <vector>
#include <cstdlib> // abs()
#include "datatypes.h"
#include "prologin.hh"
#include "zonedef.h"

class Astar
{
    public:
        Astar(Grid igrid, position idpos, position iapos); // input (depart|arrivée) position
        std::vector<position> getpath();


    private: //meth
        std::vector<Case*> adjacentToOpen(int x, int y);
        int calculePoids(int x, int y, Case* forceParent=NULL);
        std::vector<position> definepath();
        bool unwalkable_reachable(short areanum, ArrayMatrix zones);
       
    private:
        Grid grid;
        position dpos;
        position apos;
        std::vector<Case*> openlist;
        std::vector<Case*> closedlist;
};

#endif
