#include "pathfinding.h"
using namespace std;
        bool owned(powerunitsupp powunit);
        bool isMyLight(int x, int y);


/*
 * TODO
 * inclure la possibilité d'aller jusqu'à la case
 */

Pathfinding::Pathfinding(position icurrpos, int iintensite_dispo) : currpos(icurrpos),  intensite_dispo(iintensite_dispo)
{
    // something needed ?
}

vector<position> Pathfinding::optimalgen()
{
    vector<unite_energie> bunits=unites_energie();
    vector<powerunitsupp> units;

    for(unsigned i=0;i<bunits.size();i++)
    {
        units.push_back(powerunitToSupp(bunits[i]));

        // remove les déjà en contact
        if(owned(units[i]))
            units.erase(units.begin()+i);
    }

    cout << "[DBG] IN LIST FOR PLAYER " << mon_equipe() << " : " << endl;
    for(unsigned i=0;i<units.size();i++)
        cout << "at " << units[i].pos.x << ";" << units[i].pos.y << endl;

    for(unsigned i=0;i<units.size();i++)
    {
        units[i].paCost=definePaCost(units[i]);
    }
    sortVector(units);

    return units[0].optpath;
}

powerunitsupp Pathfinding::powerunitToSupp(unite_energie input)
{
    powerunitsupp out;
    out.id=input.id;
    out.pos=input.pos;
    out.valeur=input.valeur;
    out.valeur_max=input.valeur_max;
    out.paCost=-1;

    return out;
}

int Pathfinding::definePaCost(powerunitsupp &powunit)
{
    // TODO : OPTIMISER CECI !!1

    vector<position> path;

    position p=powunit.pos;
    p.x++;
    path=chemin(currpos, p);

    if(path.size()==0) // empty path
        return UNREACHABLE_NOPATH;

    powunit.optpath=path;

    return path.size();
}

Dir Pathfinding::direction(std::vector<position> path, unsigned int id1, int *dirconst)
{
    if(path.size()-1 > id1) // vector de taille suffisante
    {
        if(path[id1].x == path[id1+1].x)
        {
            if(dirconst!=NULL)
                *dirconst=path[id1].x;
            return H;
        }
        else if(path[id1].y == path[id1+1].y)
        {
            if(dirconst!=NULL)
                *dirconst=path[id1].y;
            return V;
        }
    }

    return OTH;
}

int Pathfinding::directline(std::vector<position> path, int id1) 
{
    // on pourrait utiliser direction() jusqu'à ce que ça change, mais !optimisé

    int dirconst=0;
    Dir dir = direction(path, id1, &dirconst);

    int count=0;

    if(dir==H)
    {
        for(count=id1;path[count].x == dirconst;count++); // to check
    }
    else if(dir==V)
    {
        for(count=id1;path[count].y == dirconst;count++); // to check
    }
    else
    {
        cerr << "ERROR: direction invalide" << endl;
        return -1;
    }

    return count; // TO CHECK !!1
}

void Pathfinding::sortVector(vector<powerunitsupp>& toSort) // trie par PA nécessaires, puis par puissance du générateur
{
    unsigned elemToSort=toSort.size()-1;

    // Ne nous faisons pas ch***, tri à bulles sera suffisant
    for(unsigned i=0;i<toSort.size();i++, elemToSort--)
    {
        for(unsigned j=0;j<elemToSort;j++)
        {
            if(toSort[j].paCost > toSort[j+1].paCost)
            {
                // swap les deux elem
                powerunitsupp cache=toSort[j+1];
                toSort[j+1]=toSort[j];
                toSort[j]=cache;
            }
        }
    }
    // EN THÉORIE, ici, le tableau est trié par PA. En théorie.

    for(unsigned i=0, elemToSort=toSort.size()-1;i<toSort.size();i++, elemToSort--)
    {
        for(unsigned j=0;j<elemToSort;j++)
        {
            if(generatorValue(toSort[j]) < generatorValue(toSort[j+1])
                    && toSort[j].paCost==toSort[j+1].paCost) // Si la valeur de PA est la même mais que generatorValue est plus haute
            {
                // swap les deux elem
                powerunitsupp cache=toSort[j+1];
                toSort[j+1]=toSort[j];
                toSort[j]=cache;
            }
        }
    }

    // AGAIN : EN THÉORIE, le tableau est classé par PA, et intérieurement par
    // poids
}

int Pathfinding::generatorValue(powerunitsupp gen)
{
    return ((gen.valeur*3)+gen.valeur_max) / 4; // "poids" d'un générateur, privilégie les générateurs ayant une grande valeur courrement, mais utilise valeur_max aussi
}


Grid Pathfinding::genereGrid()
{
    //    vector<vector<Case*> > grid(0,vector<Case*>());

    emptyGrid(); // reset de la grid

    for(int i=0;i<TAILLE_TERRAIN;i++)
    {
        vector<Case*> partgrid;
        for(int j=0;j<TAILLE_TERRAIN;j++)
        {
            Case* c=new Case;
            position pos;
            pos.x=j;
            pos.y=i;

            c->walkable=case_traversable(pos);
            c->x=j;
            c->y=i;
            c->parent=NULL;
            c->poids=-1;
            partgrid.push_back(c);
        }
        grid.push_back(partgrid);
    }

    return grid; // useless.
}

void Pathfinding::emptyGrid()
{
    /*
       for(unsigned i=0;i<grid.size();i++)
       {
       for(unsigned j=0;j<grid[i].size();j++)
       {
       delete grid[i][j];
       }
       }
       */
}

bool Pathfinding::owned(powerunitsupp powunit)
{
    int x=powunit.pos.x, y=powunit.pos.y;

    if(isMyLight(x-1,y) || isMyLight(x-1,y-1) || isMyLight(x,y-1) || isMyLight(x+1,y-1)
            || isMyLight(x+1,y) || isMyLight(x+1,y+1) || isMyLight(x,y+1) || isMyLight(x-1,y+1))
    {
        return true;
    }
    return false;
}

bool Pathfinding::isMyLight(int x, int y)
{
    int me=mon_equipe();

    if(x<0 || x >= TAILLE_TERRAIN || y<0 || y>=TAILLE_TERRAIN) // hors-map
        return false;


    vector<trainee_moto> trainees=trainees_moto(); // on select les trainees

    // eliminat° de celles adverses + reperage de la case cherchee
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].team != me)
            trainees.erase(trainees.begin()+i);
        for(unsigned j=0;j<trainees[i].emplacement.size();j++)
        {
            if(trainees[i].emplacement[j].x == x
                    && trainees[i].emplacement[j].y == y) // same case
                return true;
        }
    }


    return false;
}

Pathfinding::~Pathfinding()
{
    emptyGrid();
}

