#include "pathfinding.h"

using namespace std;

Pathfinding::Pathfinding(position icurrpos, int iintensite) :
    currpos(icurrpos), intensite(iintensite)
{
}

vector<position> Pathfinding::optimalgen()
{
    powerunits=unites_energie();
    for(unsigned i=0;i<powerunits.size();i++)
    {
        if(owned(powerunits[i]))
            powerunits.erase(powerunits.begin()+i);
    }

    vector<position> lowpath;
    bool once=true;

    // =============
    position pos;
    pos.x=pos.y=0;
    std::vector<position> adjaToAdd(8,pos);

    adjaToAdd[0].x=0;
    adjaToAdd[0].y=-1;

    adjaToAdd[1].x=1;
    adjaToAdd[1].y=-1;

    adjaToAdd[2].x=1;
    adjaToAdd[2].y=0;

    adjaToAdd[3].x=1;
    adjaToAdd[3].y=1;

    adjaToAdd[4].x=0;
    adjaToAdd[4].y=1;

    adjaToAdd[5].x=-1;
    adjaToAdd[5].y=1;

    adjaToAdd[6].x=-1;
    adjaToAdd[6].y=0;

    adjaToAdd[7].x=-1;
    adjaToAdd[7].y=-1;
    // =============

    for(unsigned i=0;i<powerunits.size();i++)
    {
        vector<position> tmppath;

        position side=powerunits[i].pos;
        side.x++;

        // heuristic + facteurs : case la + intéressante
        AssocInt def;
        def.id=0;
        def.v=0;
        vector<AssocInt> heuristic(8,def);

        for(unsigned j=0;j<8;j++)
        {
            heuristic[j].id=j;

            position posarrival=powerunits[i].pos;
            posarrival.x+=adjaToAdd[j].x;
            posarrival.y+=adjaToAdd[j].y;
            heuristic[j].v=abs(currpos.x - posarrival.x) + abs(currpos.y - posarrival.y); // Manatthan
        }

        // tri a bulles
        int max=heuristic.size()-1;
        for(unsigned j=0;j<heuristic.size();j++, max--)
        {
            for(int k=0;k<max;k++)
            {
                if(heuristic[k].v > heuristic[k+1].v)
                {
                    AssocInt cache = heuristic[k+1];
                    heuristic[k+1]=heuristic[j];
                    heuristic[k]=cache;
                }
            }
        }

        int idOpti=heuristic[0].id;

        position aim=powerunits[i].pos;
        aim.x+=adjaToAdd[idOpti].x;
        aim.y+=adjaToAdd[idOpti].y;

        tmppath = chemin(currpos, aim);

        if((tmppath.size()<lowpath.size() || once) && tmppath.size()!=0)
        {
            once=false;
            lowpath=tmppath;
        }
    }

    return lowpath;
}

bool Pathfinding::owned(unite_energie powunit)
{
    int x=powunit.pos.x, y=powunit.pos.y;

    if(isMyLight(x-1,y) || isMyLight(x-1,y-1) || isMyLight(x,y-1) || isMyLight(x+1,y-1)
            || isMyLight(x+1,y) || isMyLight(x+1,y+1) || isMyLight(x,y+1) || isMyLight(x-1,y+1))
    {
        return true;
    }
    return false;
}

bool Pathfinding::isMyLight(int x, int y)
{
    int me=mon_equipe();

    if(x<0 || x >= TAILLE_TERRAIN || y<0 || y>=TAILLE_TERRAIN) // hors-map
        return false;


    vector<trainee_moto> trainees=trainees_moto(); // on select les trainees

    // eliminat° de celles adverses + reperage de la case cherchee
    for(unsigned i=0;i<trainees.size();i++)
    {
        if(trainees[i].team != me)
            trainees.erase(trainees.begin()+i);
        for(unsigned j=0;j<trainees[i].emplacement.size();j++)
        {
            if(trainees[i].emplacement[j].x == x
                    && trainees[i].emplacement[j].y == y) // same case
                return true;
        }
    }


    return false;
}

