#include "zonedef.h"

using namespace std;

Zonedef::Zonedef(ArrayMatrix &imatrix) :
    matrix(imatrix)
{
    // opération très complexe : ici, on ne fout RIEN.
}

ArrayMatrix Zonedef::run(Grid grid)
{
    vector<vector<short> > matrix(0,vector<short>()); // ArrayMatrix
    for(unsigned i=0;i<grid.size();i++)
    {
        vector<short> tmpvect;
        for(unsigned j=0;j<grid[i].size();j++)
        {
            if(!grid[i][j]->walkable)
                tmpvect.push_back(0);
            else
                tmpvect.push_back(-1);
        }
        matrix.push_back(tmpvect);
    }

    Zonedef zonedef(matrix);
    zonedef.exec();
    return matrix;
}

void Zonedef::exec()
{
    int areaid=1;
    while(1)
    {
        bool foundOne=false;
        for(unsigned i=0;i<matrix.size();i++)
        {
            for(unsigned j=0;j<matrix[i].size();j++)
            {
                if(matrix[i][j] == -1)
                {
                    recursFloodFill(j,i,areaid);
                    foundOne=true;
                    break; // on reprend le while du début
                }
            }
            if(foundOne)
                break; // on reprend le while du début
        }
        if(!foundOne)
            break;
        areaid++;
    }
}

void Zonedef::recursFloodFill(int x, int y, int idarea)
{
    if(matrix[y][x]!=-1)
        return;
    matrix[y][x]=idarea;

    // recurs
    callrecurs(x-1,y,idarea);
    callrecurs(x+1,y,idarea);
    callrecurs(x,y-1,idarea);
    callrecurs(x,y+1,idarea);
}

void Zonedef::callrecurs(int x, int y, int idarea)
{
    if((unsigned)x>=0 && (unsigned)x < matrix[0].size() && (unsigned)y >= 0 && (unsigned)y < matrix.size())
    {
        recursFloodFill(x,y,idarea);
    }
}


